% calculates reference model for EV non-adaptive consumption

function[SOC, Energy_Charged, P_up, P_down, ConsumE, fval_up,...
    fval_down] = Non_Adapt(EV_n, EV_P, EV_E, EV_batt, subrange,...
    range_1, range_2, Penet_local, usage, available_local, charging,...
    SOC_0,i,conv,sch)

%% Initialize variables
SOC = zeros(1,length(subrange)+1); % vector length of subrange
SOC (1) = SOC_0;
Energy_Charged = zeros(1,length(subrange));
P_up = zeros(1,6);
P_down = zeros(1,6);
fval_up = 0;
fval_down = 0;

%% Calculated variables
driven_EV = usage * EV_n; % number of EVs being driven
Avai_P_EV = charging*EV_n*EV_P/1000; % MW - available power to be absorved by EV at every hour of the day
Max_SOC = (EV_batt * EV_n)/1000; % MWh
ConsumE = (driven_EV * EV_E)/1000; % MWh - Energy consumed by EV when being driven

%% loop
for i=1:length(subrange)
    if SOC (i) < 0.9 * Max_SOC
        Energy_Charged(i) = charging (i)*(0.9*Max_SOC-SOC(i));
            if Energy_Charged(i) > Avai_P_EV (i)
                Energy_Charged (i) = Avai_P_EV (i);
            end
        SOC(i+1) = SOC (i) + Energy_Charged (i) - ConsumE (i);
    else
        Energy_Charged(i) = 0;
        SOC(i+1) = SOC (i) - ConsumE (i);
    end  
end