function [f,xx_yy] = OF_down_DE(xx_yy) % downward regulation 

load variables_down.mat
Ener_down = 4*xx_yy.*f_AS_down;

% objective function
maxi = sum(xx_yy); % maximize the ratio of power and wind penetration
f = -1*(maxi);

% Constraints
SOC_ini = SOC_up(1);
SOC_blk = reshape(SOC_up(2:25),4,6);
SOC = [SOC_ini SOC_blk(end,:)]; % initialize SOC value
SOC_down = [SOC_ini zeros(1,6)];

for i=1:6 % SOC of the blocks
    SOC_down(i+1) = SOC(i+1) + sum(Ener_down(1:i));
    if SOC_down(i+1) > 0.9*Max_SOC
        f = f + 20*(SOC_down(i+1)-0.9*Max_SOC);
    end
end

% Boundaries
for i = 1:6
    if P_pre_down (i) < 0.3
        xx_yy(i) = 0;   
    elseif xx_yy(i) > P_pre_down (i)
        f = f + 10*(xx_yy(i)-P_pre_down (i));
    elseif xx_yy(i) < 0.3
        f = f + 20*(sqrt(xx_yy(i)^2));
    end
end
