function [f,xx_yy] = OF_up_DE_uni(xx_yy) % upward regulation 

load variables_up.mat
Media_fun = Media - 0.5; % penalize blocks with penetration lower than 0.5
SOC = zeros(1,7);

% objective function
maxi = sum(xx_yy.*Media_fun); % maximize the ratio of power and wind penetration
f = -1*(maxi);

% Constraints
SOC(1) = SOC_ini;
for i=1:6 % SOC of the blocks
    SOC(i+1) = SOC(i) + 4*xx_yy(i)*(1-f_AS_up(i)) - ConsumE_blk(i);
    if SOC(i+1) > SOC_max (i)
        f = f + 10*(SOC(i+1)-SOC_max(i));
    end
end

if SOC(3) < 0.5*Max_SOC % constraint low SOC
    f = f + 3*(0.5*Max_SOC - SOC(3));
end

% Boundaries
for i = 1:6
    if xx_yy(i) > min_Avai_P (i)
        f = f + 10*(xx_yy(i)-min_Avai_P (i));
    elseif xx_yy(i) < 0.3
        f = f + 10*(sqrt(xx_yy(i)^2));
    end
    if xx_yy(i) < 0 
        xx_yy(i) = 0; 
    end
end
