clear all; clc; close all;

% Initialize variables
count_up = zeros(4,1);
count_down = zeros(4,1);
P_up = zeros(4,1);
P_down = zeros(4,1);
r = 4; % number of rows in the matrix
Matrix = zeros(r,8);

%% Input variables
flag_conv = 0;
flag_week = 0;
while flag_conv == 0
prompt_conv = 'Choose the converter capability: \n 1 - Uni-directional \n 2 - Bi-directional \n ';
conv = input(prompt_conv);
if conv == 1 | conv == 2
    flag_conv = 1;
else
    disp('value not accepted. Choose again')
end
end

while flag_week == 0
prompt_week = 'Choose week penetration: \n 1 - Low \n 2 - High \n ';
week = input(prompt_week);
if week == 1 | week == 2
    flag_week = 1;
else
    disp('value not accepted. Choose again')
end
end

%% Import values
load('Tables/Week_Results/Non_Adapt.mat')
Bid(1,:) = Bid_cat;
Ene_AS_down(1,:) = Ene_AS_down_cat;
Ene_AS_up(1,:) = Ene_AS_up_cat;
Power_down(1,:) = Power_down_blk_cat;
Power_up(1,:) = Power_up_blk_cat;
SOC(1,:) = SOC_cat;

if conv == 1 % uni-directional
    if week == 1 % low penetration
        load('Tables/Week_Results/Basic_uni_L.mat')
    else
        load('Tables/Week_Results/Basic_uni_H.mat')
    end
else
    if week == 1 % low penetration
        load('Tables/Week_Results/Basic_bi_L.mat')
    else
        load('Tables/Week_Results/Basic_bi_H.mat')
    end   
end
Bid(2,:) = Bid_cat;
Ene_AS_down(2,:) = Ene_AS_down_cat;
Ene_AS_up(2,:) = Ene_AS_up_cat;
Power_down(2,:) = Power_down_blk_cat;
Power_up(2,:) = Power_up_blk_cat;
SOC(2,:) = SOC_cat;

if conv == 1 % uni-directional
    if week == 1 % low penetration
        load('Tables/Week_Results/GSA_uni_L.mat')
    else
        load('Tables/Week_Results/GSA_uni_H.mat')
    end
else
    if week == 1
        load('Tables/Week_Results/GSA_bi_L.mat')
    else
        load('Tables/Week_Results/GSA_bi_H.mat')
    end 
end
Bid(3,:) = Bid_cat;
Ene_AS_down(3,:) = Ene_AS_down_cat;
Ene_AS_up(3,:) = Ene_AS_up_cat;
Power_down(3,:) = Power_down_blk_cat;
Power_up(3,:) = Power_up_blk_cat;
SOC(3,:) = SOC_cat;
fval(1,1) = fval_up_w;
fval(1,2) = fval_down_w;

if conv == 1 % uni-directional
    if week == 1 % low penetration
        load('Tables/Week_Results/GA_uni_L.mat')
    else
        load('Tables/Week_Results/GA_uni_H.mat')
    end
else
    if week == 1
        load('Tables/Week_Results/GA_bi_L.mat')
    else
        load('Tables/Week_Results/GA_bi_H.mat')
    end 
end
Bid(4,:) = Bid_cat;
Ene_AS_down(4,:) = Ene_AS_down_cat;
Ene_AS_up(4,:) = Ene_AS_up_cat;
Power_down(4,:) = Power_down_blk_cat;
Power_up(4,:) = Power_up_blk_cat;
SOC(4,:) = SOC_cat;
fval(2,1) = fval_up_w;
fval(2,2) = fval_down_w;

if conv == 1 % uni-directional
    if week == 1 % low penetration
        load('Tables/Week_Results/DE_uni_L.mat')
    else
        load('Tables/Week_Results/DE_uni_H.mat')
    end
else
    if week == 1
        load('Tables/Week_Results/DE_bi_L.mat')
    else
        load('Tables/Week_Results/DE_bi_H.mat')
    end 
end
Bid(5,:) = Bid_cat;
Ene_AS_down(5,:) = Ene_AS_down_cat;
Ene_AS_up(5,:) = Ene_AS_up_cat;
Power_down(5,:) = Power_down_blk_cat;
Power_up(5,:) = Power_up_blk_cat;
SOC(5,:) = SOC_cat;
fval(3,1) = fval_up_w;
fval(3,2) = fval_down_w;

clearvars Bid_cat Ene_AS_down_cat Ene_AS_up_cat Power_down_blk_cat...
    Power_up_blk_cat SOC_cat

%% Matrix creation

% Initialize variable

Matrix(1:r,1) = SOC(1:r,1); % SOC Initial
Matrix(1:r,2) = SOC(1:r,end); % SOC Final
Matrix(1:r,3) = sum(Bid(1:r,:),2);
Matrix(1:r,4) = Bid(1:r,:)*Penetration./Matrix(:,3);

for a = 1:r % Different algorithims
    for b = 1:length(Power_up(a,:)) % Power blocks
        if Power_up(a,b) >= 0.3
            count_up(a) = count_up(a) + 1;
            P_up(a) = P_up(a) + Power_up(a,b);
        end
        if Power_down(a,b) >= 0.3
            count_down(a) = count_down(a) + 1;
            P_down(a) = P_down(a) + Power_down(a,b);
        end
    end
end

Matrix(1:r,5) = count_up;
Matrix(1:r,6) = P_up;
Matrix(1:r,7) = P_up./count_up;
Matrix(1:r,8) = count_down;
Matrix(1:r,9) = P_down;
Matrix(1:r,10) = P_down./count_down;

filename = 'Excel/table_week.xlsx';
if conv == 1
    sheet = 1; %unidirectional
else
    sheet = 2; % bidirectional
end
if week == 1 % low penetration
    xlRange = 'B5';   
    xlRange_2 = 'B25';
else % high penetration
    xlRange = 'B15';
    xlRange_2 = 'D25';
end
xlswrite(filename,Matrix,sheet,xlRange)
xlswrite(filename,fval,sheet,xlRange_2)