clear all; clc; close all;

%% Import values
flag = 0;
while flag == 0
prompt = 'Choose the converter capability: \n 1 - Uni-directional \n 2 - Bi-directional \n ';
conv = input(prompt);
if conv == 1 | conv == 2
    flag = 1;
else
    disp('value not accepted. Choose again')
end
end

load content.mat
load 'DK1.mat'
cf_wind_20 = 1.32;
cf_con_20 = 1.01;
W_prog_20 = DK1.four.wind.prognosis * cf_wind_20; % MWh - wind prognosis
C_prog_20 = DK1.four.consumption.prognosis * cf_con_20; % MWh - Consumption prognosis
Penetration_prog_20 = (W_prog_20)./C_prog_20;
W_meas_20 = DK1.four.wind.measured * cf_wind_20; % MWh - wind prognosis
C_meas_20 = DK1.four.consumption.measured * cf_con_20; % MWh - Consumption prognosis
Penetration_meas_20 = (W_meas_20)./C_meas_20;
spot = DK1.four.spot; % DKK/MWh - prices in the Elspot market
n = 5; % number of rows
xlrange_1 = 'B4';
xlrange_2 = 'B23';

load('Tables/Year_Results/Non_Adapt.mat')
Bid(1,:) = matrix_large(:,3);
Ene_AS_down(1,:) = matrix_large(:,4);
Ene_AS_up(1,:) = matrix_large(:,5);
Power_down(1,:) = matrix_short(:,3);
Power_up(1,:) = matrix_short(:,4);
% SOC(1,:) = SOC_adapt_cat;

if conv == 1
    load('Tables/Year_Results/Basic_uni_Y.mat')
else
    load('Tables/Year_Results/Basic_bi_Y.mat')
end
Bid(2,:) = matrix_large(:,3);
Ene_AS_down(2,:) = matrix_large(:,4);
Ene_AS_up(2,:) = matrix_large(:,5);
Power_down(2,:) = matrix_short(:,3);
Power_up(2,:) = matrix_short(:,4);
% SOC(2,:) = SOC_adapt_cat;

if conv == 1
    load('Tables/Year_Results/GSA_uni_Y.mat')
% load('M:/Thesis/matlab/Optimization functions/Gradient Search Algorithm/uni-directional/results_gsa.mat')
else
    load('Tables/Year_Results/GSA_bi_Y.mat')
% load('M:/Thesis/matlab/Optimization functions/Gradient Search Algorithm/bi-directional/results_gsa.mat')
end
Bid(3,:) = matrix_large(:,3);
Ene_AS_down(3,:) = matrix_large(:,4);
Ene_AS_up(3,:) = matrix_large(:,5);
Power_down(3,:) = matrix_short(:,3);
Power_up(3,:) = matrix_short(:,4);
% SOC(3,:) = SOC_adapt_cat;

if conv == 1
    load('Tables/Year_Results/GA_uni_Y.mat')
% load('M:/Thesis/matlab/Optimization functions/Genetic Algorithm/uni-directional/results_ga_new.mat')
else
    load('Tables/Year_Results/GA_bi_Y.mat')
% load('M:/Thesis/matlab/Optimization functions/Genetic Algorithm/bi-directional/results_ga_new.mat')
end
Bid(4,:) = matrix_large(:,3);
Ene_AS_down(4,:) = matrix_large(:,4);
Ene_AS_up(4,:) = matrix_large(:,5);
Power_down(4,:) = matrix_short(:,3);
Power_up(4,:) = matrix_short(:,4);
% % SOC(4,:) = SOC_adapt_cat;

if conv == 1
    load('Tables/Year_Results/DE_uni_Y.mat')
% load('M:/Thesis/matlab/Optimization functions/Differential Evolution/uni-directional/results_de.mat')
else
    load('Tables/Year_Results/DE_bi_Y.mat')
% load('M:/Thesis/matlab/Optimization functions/Differential Evolution/bi-directional/results_de_v2.mat')
end
Bid(5,:) = matrix_large(:,3);
Ene_AS_down(5,:) = matrix_large(:,4);
Ene_AS_up(5,:) = matrix_large(:,5);
Power_down(5,:) = matrix_short(:,3);
Power_up(5,:) = matrix_short(:,4);
% % SOC(5,:) = SOC_adapt_cat;


%% Matrix creation
% Initialize variable
Matrix = zeros(n,10);
count_up = zeros(n,1);
count_down = zeros(n,1);
P_up = zeros(n,1);
P_down = zeros(n,1);

% Day-ahead
Matrix(1:n,1) = sum(Bid(1:n,:),2);
Matrix(1:n,2) = Bid(1:n,:)*spot;
Matrix(1:n,3) = Matrix(1:n,2)./Matrix(1:n,1)/1000;
for a = 1:n
Matrix(a,4) = sum(Bid(a,:)'.*Penetration_meas_20)/Matrix(a,1);
end

for a = 1:n % Different algorithims
    for b = 1:length(Power_up(a,:)) % Power blocks
        if Power_up(a,b) >= 0.3
            count_up(a) = count_up(a) + 1;
            P_up(a) = P_up(a) + Power_up(a,b);
        end
        if Power_down(a,b) >= 0.3
            count_down(a) = count_down(a) + 1;
            P_down(a) = P_down(a) + Power_down(a,b);
        end
    end
end

% Upward
Matrix(1:n,5) = count_up;
Matrix(1:n,6) = count_up/2190; % percentage up
Matrix(1:n,7) = P_up; % volume of upward regulation
Matrix(1:n,8) = sum(Ene_AS_up(1:n,:),2); % Energy

% Downward
Matrix(1:n,9) = count_down;
Matrix(1:n,10) = count_down/2190;
Matrix(1:n,11) = P_down;
Matrix(1:n,12) = sum(Ene_AS_down(1:n,:),2);

% Wind content
Content = zeros(a,3);
for a = 1:n
Content(a,1) = sum(Bid(a,:).*Vind_content)/Matrix(a,1);
Content(a,2) = sum(Bid(a,:).*Centrale_content)/Matrix(a,1);
Content(a,3) = sum(Bid(a,:).*Decentrale_content)/Matrix(a,1);
end

% if conv == 1
%     save Import_regulation_uni.mat Matrix
% else
%     save Import_regulation_bi.mat Matrix
% end

%% Create Excel file
filename = 'Excel/table_year.xlsx';
if conv == 1
    sheet = 1; %unidirectional
else
    sheet = 2; % bidirectional
end
xlswrite(filename,Matrix,sheet,xlrange_1)
xlswrite(filename,Content,sheet,xlrange_2)
